



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java 集合框架(二)Iterable接口</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java 集合框架(二)Iterable接口</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 17:02:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　Iterable接口是java 集合框架的顶级接口,实现此接口使集合对象可以通过迭代器遍历自身元素,我们可以看下它的成员方法</p>
<table>
<tbody>
<tr>
<td><strong>修饰符和返回值</strong></td>
<td><strong>方法名</strong></td>
<td><strong>描述</strong></td>
</tr>
<tr>
<td>Iterator&lt;T&gt;</td>
<td><strong>iterator</strong>()</td>
<td>返回一个内部元素为T类型的迭代器</td>
</tr>
<tr>
<td>default void</td>
<td><strong>forEach</strong>(Consumer&lt;? super&nbsp;<a href="http://docs.oracle.com/javase/8/docs/api/java/lang/Iterable.html" rel="external nofollow noreferrer">T</a>&gt;&nbsp;action)</td>
<td>对内部元素进行遍历,并对元素进行指定的操作</td>
</tr>
<tr>
<td>default&nbsp;Spliterator&lt;T&gt;</td>
<td><strong>spliterator</strong>()</td>
<td>创建并返回一个可分割迭代器</td>
</tr>
</tbody>
</table>
<p>　　Iterable最早出现在JDK 1.5,开始只有iterator()一个抽象方法,需要子类来实现一个内部迭代器Iterator遍历元素.后两个方法是Java 8后新添加的,forEach(Consumer action)是为了方便遍历操作集合内的元素,spliterator()则提供了一个可以并行遍历元素的迭代器,以适应现在cpu多核时代并行遍历的需求.</p>
<p>　　其中我们可以看下default修饰符,这也是Java 8后新出现的,我们知道,如果我们给一个接口新添加一个方法,那么所有他的具体子类都必须实现此方法,为了能给接口拓展新功能,而又不必每个子类都要实现此方法,Java 8新加了default关键字,被其修饰的方法可以不必由子类实现,并且由dafault修饰的方法在接口中有方法体,这打破了Java之前对接口方法的规范.</p>
<p>　　下面是使用迭代器进行遍历的例子</p>
<div>
<pre class="prettyprint linenums">public class IterableTest {<br />
    public static void main(String[] args) {<br />
        iteratorCase();<br />
    }<br />
    public static void iteratorCase(){<br />
        List&lt;Integer&gt; list=new ArrayList&lt;Integer&gt;();<br />
        list.add(1);<br />
        list.add(2);<br />
        list.add(3);<br />
        list.add(4);

        Iterator&lt;Integer&gt; iterator=list.iterator();  //获取ArrayList内部迭代器<br />
        while(iterator.hasNext()){                   //hasNext()方法判断是否还有元素<br />
            System.out.println(iterator.next());     //next()返回当前元素,并且将指针移向下个元素<br />
        }<br />
    }<br />
}</pre>
</div>
<p>　　此外我们还可以使用"for-each loop"形式进行遍历,增强for形式在Java中只是一个语法糖,实际编译的时候,还是会转换为迭代器形式,上面方法体可以改成</p>
<div>
<pre class="prettyprint linenums">for (Integer integer : list) {<br />
         System.out.println(integer);<br />
     }</pre>
</div>
<p>　　进行迭代遍历的时候我们需要注意这种情况,就是在遍历的过程中,如果我们对元素进行添加删除,那么会造成并行修改异常(ConcurrentModificationException),如下</p>
<div>
<pre class="prettyprint linenums">　　　　 Iterator&lt;Integer&gt; iterator = list.iterator();<br />
        while (iterator.hasNext()) {<br />
            Integer i = iterator.next();<br />
            if (i == 2) {<br />
                list.remove(i);<br />
            }<br />
        }</pre>
</div>
<p>　　对于这种情况,,我们应当使用迭代器Iterator内部的remove()方法,而不是使用集合list直接删除元素,正确写法为</p>
<div>
<pre class="prettyprint linenums">Iterator&lt;Integer&gt; iterator = list.iterator();<br />
        while (iterator.hasNext()) {<br />
            Integer i = iterator.next();<br />
            if (i == 2) {<br />
                iterator.remove();            //使用迭代器进行删除元素,注意这里remove()没有参数,它是直接删除当前迭代的元素<br />
            }<br />
        }</pre>
</div>
<p>　　如果我们自己想自己写一个集合,实现Iterable接口,并可以使用"for-each loop"形式遍历,那么我们需要自己来重写一个迭代器(Iterator)并返回它,看下面代码</p>
<div>
<pre class="prettyprint linenums">public class MyCollection&lt;E&gt; implements Iterable&lt;E&gt; {<br />
    @Override<br />
    public Iterator iterator() {<br />
        return new MyIterator();<br />
    }

    private class MyIterator implements Iterator&lt;E&gt;{<br />
        @Override<br />
        public boolean hasNext() {<br />
            return false;<br />
        }<br />
        @Override<br />
        public E next() {<br />
            return null;<br />
        }<br />
    }<br />
}</pre>
</div>
<p>　　这样就可以使用"for-each loop"的形式进行遍历</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/3902xvoq.html">C&num;&period;NET 大型企业信息化系统集成快速开发平台 4&period;2 版本 - 多软件系统集成缓存体系改进</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r0xzd9.html">HalconMFC&lpar;一&rpar;之多版本配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv3orz8.html">ios跑酷游戏源码完整版</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e7n1m9.html">iScroll&period;js 用法参考 （share）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyjm42q.html">CSS3 旋转代码备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd5lje8.html">九度OJ1468</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde41e79.html">ios中框架介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj4m6lq.html">Yii CDBCriteria常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljn30e9.html">搭建Minisipserve服务器实现局域网内IOS客户端idoubs的通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj4krk8.html">Linux修改date</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yz1jg8.html">Hackers&amp;&num;39&semi; Crackdown UVA - 11825 （状压dp）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydprxq.html">&lbrack;SQL&rsqb;事务回滚详解及示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2jzk6q.html">【English】20190306</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r567keq.html">清除微信小程序的缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd6m6j9.html">HTTP各种特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kje3w69.html">Object value iterator：值迭代器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9634ge39.html">&lbrack;整理&rsqb;SQL Server Reporting Services Charts</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjv63p8.html">最简单的回射客户&sol;服务器程序、time&lowbar;wait 状态</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2v1ke8.html">Linux --- Ubuntu16&period;04&period;5 LTS 虚拟机安装后的软件安装基础操作总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlo1vzxq.html">Action与Func 用法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zoxz43q.html">sizeof和strlen的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gek7xz8.html">2、jQuery的一些静态方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzg3yl8.html">javase学习小结三</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1xzo2q.html">让windows系统的DOS窗口也可以显示utf8字符集</a>
			</li>
						<li><a href="https://www.batexi.com/a/950y2e68.html">ABP官方文档翻译 7&period;1 后台Jobs和Workers</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp4y069.html">Android Studio 3&period;1 Beta 1发布，如何及时下载更新</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mez3npq.html">asp&period;net 文件上传 Uploadify HTML5 带进度条</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z362g9.html">Oracle RAC基本概念</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjekel8.html">MongoDB - Indexing&comma; Replication&comma; and Security</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1ldl2q.html">发送POST测试请求的若干方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
